# Deep Learning with Data Privacy via Residual Perturbation

## Folder description

Here is a list of all the python files included:

* `membership_inference_attack.py`: perform membership inference attack using Cifar10 and Cifar100 dataset.

* `membership_inference_attack_IDC.py`: perform membership inference attack using IDC dataset.

* `prepare_IDCdata.py`: prepare custom dataloader for IDC dataset.

* `metrics.py`: obtain the results of the membership inference attack.

* `train.py`: provide the training function.

* `resnet_cifar.py`: provide the network architecture for the shadow model and the target model.

* `model.py`: provide the network architecture for the attack model.

## Experiment requirements

To run the code, following libraies are required

* Python >= 3.5
* PyTorch >= 1.0
* torchvision >= 0.2

## Code
```
## membership inference attack using Cifar10 dataset
python membership_inference_attack.py

## membership inference attack using IDC dataset
python membership_inference_attack_IDC.py
```
